** Author: Stphane DESNAULT - SOFTWARE ASSETS
** 
** 12 rue Franois Grard
** 75016 PARIS - FRANCE
** 
** Tel : (331) 40 50 39 40
** Fax : (331) 40 50 39 50
** CIS : 100034,2567
** 
** If you like AEDIT and need database expertise... give us a call!
**

****************************************************************

FUNCTION aEdit

PARAMETERS laArr,laLeftT,laTopT,lcPicture, lnVCnt, lnHCnt

* laArr			: Array to edit of dimension [M,N]
* laLeftT		: Array of titles on the left of dimension [M].
* laTopT		: Array of titles on top of dimension [N]
* lcPicture : Picture of edited items
* lnVCnt		: Number of items to display vertically - optional
* lnHCnt		: Number of items to display horizontally - optional

PRIVATE lnTopRow							&& Index of top-most displayed row
PRIVATE lnLeftCol							&& Index of left-most displayed column
PRIVATE lnRow									&& CURSOR Row of current cell
PRIVATE lnCol									&& CURSOR Column of current cell
PRIVATE	i,j
PRIVATE lnCellLen							&& Length of a cell
PRIVATE lnLeftT								&& Length of first (Title) column
PRIVATE lnRowLen							&& Length of a displayed row (including titles)
PRIVATE llExit								&& Signals exit from the main loop
PRIVATE lnHElev								&& Position inside horizontal elevatotr
PRIVATE lnVElev								&& position inside vertical elevator
PRIVATE lcStatus							&& Status on exit


IF SET("TALK") = "ON"
	SET TALK OFF
	lcTalkStat = "ON"
ELSE
	lcTalkStat = "OFF"
ENDIF

lcCompStat = SET("COMPATIBLE")
SET COMPATIBLE FOXPLUS


=ACOPY(laArr,laBackup)

lnCellLen=LEN(TRANSFORM(laArr[1,1],lcPicture))+1

* Scan laLeftT for the longest title
lnLeftT=0
FOR i=1 TO ALEN(laLeftT,1)
	IF lnLeftT < LEN(ALLTRIM(laLeftT[i]))
		lnLeftT=LEN(ALLTRIM(laLeftT[i]))
	ENDIF
ENDFOR

* Compute displayed line length. Line length is either computed
* after lnHCnt if it's present or after the screen's width. If
* lnHCnt is present but too big to fit the screen it is reduced
* accordingly, ditto if the dipslayed array doesn't have that
* many columns.

IF (PARAMETERS()<6) .OR. (lnHCnt>ALEN(laArr,2))
	 lnHCnt=ALEN(laArr,2)
ENDIF


lnRowLen=lnLeftT+lnHCnt*lnCellLen
IF lnRowLen>(SCOLS()-6)
	lnHCnt=FLOOR((SCOLS()-6-lnLeftT)/lnCellLen)
	lnRowLen=lnLeftT+lnHCnt*lnCellLen
ENDIF

* Compute number of Rows displayed.
IF (PARAMETERS()<5) .OR. (lnVCnt>ALEN(laArr,1))
	lnVCnt=ALEN(laArr,1)
ENDIF

IF lnVCnt>(SROWS()-9)
	lnVCnt=(SROWS()-9)
ENDIF

DEFINE WINDOW editArray ;
		FROM INT((SROW()-(lnVCnt+9))/2),INT((SCOL()-(lnRowLen+6))/2) ;
		TO INT((SROW()-(lnVCnt+9))/2)+(lnVCnt+8),INT((SCOL()-(lnRowLen+6))/2)+(lnRowLen+5) ;
		FLOAT ;
		NOCLOSE ;
		DOUBLE ;
		COLOR SCHEME 10

ACTIVATE WINDOW editarray

lnTopRow=1
lnRow=1
lnLeftCol=1
lnCol=1
llExit=.F.
lnHElev=1
lnVElev=1
lcStatus="OK"

* Draw background lines
@ 2,1 TO 2,lnRowLen+1
@ lnVcnt+3,1 TO lnVcnt+3,IIF(lnHCnt<ALEN(laArr,2),lnLeftT,lnRowLen+1)

* Draw exit buttons
@ lnVCnt+5,WCOLS()-20 SAY "  OK    <Cancel>"

=redraw("TOP+LEFT")
=drawCursor()

DO WHILE ! llExit

	lnKeyPress=INKEY("M")

	DO CASE
		CASE lnKeypress=4																	&& Right
			=moveRight()
		CASE lnKeypress=19 OR lnKeyPress=127							&& Left/BackSpace
			=moveLeft()
		CASE lnKeypress=24																&& Down
			=moveDown()
		CASE lnKeypress=5																	&& Up
			=moveUp()
		CASE lnKeypress=1																	&& Home
			=moveHome()
		CASE lnKeypress=6																	&& End
			=moveEnd()
		CASE lnKeypress=9																	&& Tab
			=screenRight()
		CASE lnKeypress=15																&& Backtab
			=screenLeft()
		CASE lnKeypress=18																&& Page up
			=screenUp()
		CASE lnKeypress=3																	&& Page down
			=screenDown()
		CASE lnKeypress=13																&& Enter
			=editCell()
		CASE lnKeypress=10																&& Ctrl-Enter
			=exitAEdit("OK")
		CASE lnKeypress=27																&& Escape
			=exitAEdit("Cancel")
		CASE lnKeypress=151																&& Mouse
			=mousePress()
		CASE BETWEEN(lnKeypress,48,57) OR lnKeypress=45		&& "-" or digit
			SET CURSOR ON
			@ lnRow+2,lnLeftT+2+(lnCol-1)*lnCellLen GET laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1] PICTURE lcPicture
			KEYBOARD CHR(lnKeypress)
			READ
			SET CURSOR OFF
			=drawCursor()
		CASE lnKeypress=7											&& Delete
			laArr[lnTopRow+lnRow-1,lnLeftCol+lnCol-1]=0
			@ lnRow+2,lnLeftT+2+(lnCol-1)*lnCellLen SAY 0 PICTURE lcPicture
			=drawCursor()
	ENDCASE
ENDDO

RELEASE WINDOW editArray

IF lcStatus="Cancel"
	=ACOPY(laBackup,laArr)
ENDIF

SET TALK &lcTalkStat
SET COMPATIBLE &lcCompStat

RETURN lcStatus


****************************************************************


****************************************************************

FUNCTION redraw

PARAMETERS lcTitles

* Draw Col titles at the top
IF 'TOP' $ UPPER(lcTitles)
	FOR j=1 TO lnHCnt
		@ 1,lnLeftT+2+(j-1)*lnCellLen SAY PADC(ALLTRIM(laTopT[j+lnLeftCol-1]),lnCellLen)
	ENDFOR
	=drawElev("H")
ENDIF

* Draw Row titles on the left
IF 'LEFT' $ UPPER(lcTitles)
	FOR i=1 TO lnVCnt
		@ i+2,1 SAY PADR(laLeftT[i+lnTopRow-1],lnLeftT)
	ENDFOR
	=drawElev("V")
ENDIF

* Draw cells
FOR i=1 TO lnVCnt
	FOR j=1 TO lnHCnt
		@ i+2,lnLeftT+2+(j-1)*lnCellLen SAY laArr[lnTopRow+i-1,lnLeftCol+j-1] PICTURE lcPicture
	ENDFOR
ENDFOR

RETURN .T.

****************************************************************


****************************************************************

FUNCTION drawCursor

* Column Title
@ 1,lnLeftT+2+(lnCol-1)*lnCellLen FILL TO ;
	1,lnLeftT+lnCol*lnCellLen+1 COLOR (SCHEME(10,7))

* Row title
@ lnRow+2,1 FILL TO lnRow+2,1+lnLeftT COLOR (SCHEME(10,7))

* Cell
@ lnRow+2,lnLeftT+2+(lnCol-1)*lnCellLen FILL TO ;
	lnRow+2,lnLeftT+lnCol*lnCellLen+1 COLOR (SCHEME(10,2))

RETURN .T.

****************************************************************


****************************************************************

FUNCTION drawElev

PARAMETERS lcHV

* If horizontal elevator is requested...
IF 'H' $ UPPER(lcHV)
	* ...and if it is needed...
	IF lnHCnt<ALEN(laArr,2)
		* ...Draw it!
		lnHElev=(lnLeftCol+lnCol-1)*(lnCellLen*lnHCnt-1)/ALEN(laArr,2)
		@ lnVCnt+3,lnLeftT+1 SAY ""+SPACE(lnHCnt*lnCellLen-1)+"" ;
			COLOR (SCHEME(10,3))
		@ lnVCnt+3,lnLeftT+1+lnHelev SAY "" COLOR (SCHEME(10,3))
	ENDIF
ENDIF

* If vertical elevator is requested...
IF 'V' $ UPPER(lcHV)
	* ...and if it is needed...
	IF lnVCnt<ALEN(laArr,1)
		* ...Draw it!
		lnVElev=(lnTopRow+lnRow-1)*(lnVCnt-3)/ALEN(laArr,1)
		@ 2,lnRowLen+2 SAY "" COLOR (SCHEME(10,3))
		@ 3,lnRowLen+2 SAY "" COLOR (SCHEME(10,3))
		@ 4,lnRowLen+2 CLEAR TO lnVcnt+1,lnRowLen+2
		@ 4,lnRowLen+2 FILL TO lnVcnt+1,lnRowLen+2 COLOR (SCHEME(10,3))
		@ lnVCnt+2,lnRowLen+2 SAY "" COLOR (SCHEME(10,3))
		@ lnVCnt+3,lnRowLen+2 SAY IIF(lnHCnt<ALEN(laArr,2)," ","") ;
			COLOR (SCHEME(10,3))
		@ lnVElev+4,lnRowLen+2 SAY "" COLOR (SCHEME(10,3))
	ENDIF
ENDIF

RETURN .T.

****************************************************************


****************************************************************

FUNCTION clearCursor

* Column Title
@ 1,lnLeftT+2+(lnCol-1)*lnCellLen FILL TO ;
	1,lnLeftT+lnCol*lnCellLen+1 COLOR (SCHEME(10,1))

* Row title
@ lnRow+2,1 FILL TO lnRow+2,1+lnLeftT COLOR (SCHEME(10,1))

* Cell
@ lnRow+2,lnLeftT+2+(lnCol-1)*lnCellLen FILL TO ;
	lnRow+2,lnLeftT+lnCol*lnCellLen+1 COLOR (SCHEME(10,1))

RETURN .T.

****************************************************************


****************************************************************

FUNCTION editCell

SET CURSOR ON
@ lnRow+2,lnLeftT+2+(lnCol-1)*lnCellLen GET laArr[lnRow+lnTopRow-1,lnCol+lnLeftCol-1] PICTURE lcPicture
READ
SET CURSOR OFF
=drawCursor()

RETURN .T.

****************************************************************


****************************************************************

FUNCTION moveLeft

* If cursor was on the left of the screen...
IF lnCol=1
	*...Then if it's not on the left of the array...
	IF (lnLeftCol>1)
		* ...move the window one column to the left,
		* leaving cursor in place.
		lnLeftCol=lnLeftCol-1
		=redraw("TOP")
		=drawCursor()
	ENDIF
ELSE
	*...Otherwise, simply move cursor to the right.
	=ClearCursor()
	lnCol=lnCol-1
	=drawCursor()
	=drawElev("H")
ENDIF

RETURN .T.

****************************************************************


****************************************************************

FUNCTION moveRight

* If cursor was on the right of the screen...
IF lnCol=lnHCnt
	*...Then if it's not on the right of the array...
	IF (lnLeftCol+lnHCnt-1<ALEN(laArr,2))
		* ...move the window one column to the right,
		* leaving cursor in place.
		lnLeftCol=lnLeftCol+1
		=redraw("TOP")
		=drawCursor()
	ENDIF
ELSE
	*...Otherwise, simply move cursor to the right.
	=ClearCursor()
	lnCol=lnCol+1
	=drawCursor()
	=drawElev("H")
ENDIF

RETURN .T.

****************************************************************


****************************************************************

FUNCTION moveUp

* If cursor was on top of the screen...        
IF lnRow=1                                     
  *...Then if it's not on top of the array...  
  IF lnTopRow>1                                
    * ...move the window one line up,          
    * leaving cursor in place.                 
    lnTopRow=lnTopRow-1                        
    =redraw("LEFT")                            
    =drawCursor()                              
  ENDIF                                        
ELSE                                           
  *...Otherwise, simply move cursor up.        
  =ClearCursor()                               
  lnRow=lnRow-1                                
  =drawCursor()                                
	=drawElev("V")
ENDIF                                          

RETURN .T.

****************************************************************


****************************************************************

FUNCTION moveDown

* If cursor was on the bottom of the screen...
IF lnRow=lnVCnt
	*...Then if it's not on the bottom of the array...
	IF (lnTopRow+lnVCnt-1<ALEN(laArr,1))
		* ...move the window one line down,
		* leaving cursor in place.
		lnTopRow=lnTopRow+1
		=redraw("LEFT")
		=drawCursor()
	ENDIF
ELSE
	*...Otherwise, simply move cursor down.
	=ClearCursor()
	lnRow=lnRow+1
	=drawCursor()
	=drawElev("V")
ENDIF

RETURN .T.

****************************************************************


****************************************************************

FUNCTION moveHome

lctemp=""               
IF lnLeftCol>1          
  lcTemp="TOP"          
ENDIF                   
IF lnTopRow>1           
  lcTemp=lcTemp+"LEFT"  
ENDIF                   
=ClearCursor()          
lnTopRow=1              
lnLeftCol=1             
lnRow=1                 
lnCol=1                 
IF ! EMPTY(lcTemp)      
  =redraw(lcTemp)       
ENDIF                   
=drawCursor()           
=drawElev("HV")

RETURN .T.

****************************************************************


****************************************************************

FUNCTION moveEnd

lctemp=""               
IF lnLeftCol<ALEN(laArr,2)-lnHCnt+1          
  lcTemp="TOP"          
ENDIF                   
IF lnTopRow<ALEN(laArr,1)-lnVCnt+1                     
  lcTemp=lcTemp+"LEFT"  
ENDIF                   
=ClearCursor()          
lnTopRow=ALEN(laArr,1)-lnVCnt+1                                   
lnLeftCol=ALEN(laArr,2)-lnHCnt+1                                  
lnRow=lnVCnt                 
lnCol=lnHCnt                 
IF ! EMPTY(lcTemp)      
  =redraw(lcTemp)       
ENDIF                   
=drawCursor()           
=drawElev("HV")

RETURN .T.

****************************************************************


****************************************************************

FUNCTION screenLeft

* If cursor isn't on leftmost column of screen...            
IF lnCol>1                                                   
  * ...simply move it there...                               
  =clearCursor()                                             
  lnCol=1                                                    
  =drawCursor()                                              
  =drawElev("H")
ELSE                                                         
  * ...else move the window one screen left minus one column.
  lnLeftCol=IIF((lnLeftCol-lnHCnt+1)<1, ;                    
                1, ;                                         
                lnLeftCol-lnHCnt+1)                          
  =redraw("TOP")                                             
  =drawCursor()                                              
ENDIF                                                        

RETURN .T.

****************************************************************


****************************************************************

FUNCTION screenRight

* If cursor isn't on rightmost column of screen...              
IF lnCol<lnHCnt                                                 
  * ...simply move it there...                                  
  =clearCursor()                                                
  lnCol=lnHCnt                                                  
  =drawCursor()                                                 
  =drawElev("H")
ELSE                                                            
  * ...else move the window one screen right minus one column.  
  lnLeftCol=IIF((lnLeftCol+lnHCnt-1)>(ALEN(laArr,2)-lnHCnt+1), ;
                ALEN(laArr,2)-lnHCnt+1, ;                       
                lnLeftCol+lnHCnt-1)                             
  =redraw("TOP")                                                
  =drawCursor()                                                 
ENDIF                                                           

RETURN .T.

****************************************************************


****************************************************************

FUNCTION screenUp

* If cursor isn't on top line of screen...               
IF lnRow>1                                               
  * ...simply move it there...                           
  =clearCursor()                                         
  lnRow=1                                                
  =drawCursor()                                          
  =drawElev("V")
ELSE                                                     
  * ...else move the window one screen up minus one line.
  lnTopRow=IIF((lnTopRow-lnVCnt+1)<1, ;                  
                1, ;                                     
                lnTopRow-lnVCnt+1)                       
  =redraw("LEFT")                                        
  =drawCursor()                                          
ENDIF                                                    

RETURN .T.

****************************************************************


****************************************************************

FUNCTION screenDown

* If cursor isn't on bottom line of screen...                 
IF lnRow<lnVCnt                                               
  * ...simply move it there...                                
  =clearCursor()                                              
  lnRow=lnVCnt                                                
  =drawCursor()                                               
  =drawElev("V")
ELSE                                                          
  * ...else move the window one screen down minus one line.   
  lnTopRow=IIF((lnTopRow+lnVCnt-1)>(ALEN(laArr,1)-lnVCnt+1), ;
                ALEN(laArr,1)-lnVCnt+1, ;                     
                lnTopRow+lnVCnt-1)                            
  =redraw("LEFT")                                             
  =drawCursor()                                               
ENDIF                                                         

RETURN .T.

****************************************************************


****************************************************************

FUNCTION mousePress

lnMRow=MROW()
lnMCol=MCOL()

* Check exit buttons
IF lnMRow = lnVCnt+5
	* OK...
	IF BETWEEN(lnMCol,WCOLS()-20,WCOLS()-13)
		=exitAEdit("OK")
	ENDIF
	* Cancel...
	IF BETWEEN(lnMCol,WCOLS()-10,WCOLS()-3)
		=exitAEdit("Cancel")
	ENDIF
	RETURN .T.
ENDIF

* Check horizontal elevator
IF lnMRow=lnVCnt+3
	DO CASE
		* Left elevator arrow
		CASE lnMCol=lnLeftT+1
			=moveLeft()
		* Right elevator arrow
		CASE lnMCol=lnRowLen+1
			=moveRight()
		* Left elevator zone
		CASE BETWEEN(lnMCol,lnLeftT+2,lnLeftT+lnHElev)
			=screenLeft()
		* Right elevator zone
		CASE BETWEEN(lnMCol,lnLeftT+2+lnHElev,lnRowLen)
			=screenRight()
	ENDCASE
	RETURN .T.
ENDIF

* Check vertical elevator
IF lnMCol=lnRowLen+2
	DO CASE
		* Up elevator arrow
		CASE lnMRow=3
			=moveUp()
		* Down elevator arrow
		CASE lnMRow=lnVCnt+2
			=moveDown()
		* Up elevator zone
		CASE BETWEEN(lnMRow,4,3+lnVElev)
			=screenUp()
		* Down elevator zone
		CASE BETWEEN(lnMRow,4+lnVElev,lnVCnt+1)
			=screenDown()
	ENDCASE
ENDIF

* Check input zone
IF BETWEEN(lnMRow,3,lnVCnt+2)
	IF BETWEEN(lnMCol,lnLeftT+2,lnRowLen)
		=clearCursor()
		lnRow=lnMrow-2
		lnCol=CEILING((lnMCol-lnLeftT-1)/lnCellLen)
		=drawElev("HV")
		=drawCursor()
		=editCell()
	ENDIF
ENDIF

RETURN .T.

****************************************************************


****************************************************************

FUNCTION exitAEdit

PARAMETERS lcStat

DO CASE
	CASE lcStat="OK"
		* Simulate button press...
		@ lnVCnt+5,WCOLS()-20 FILL TO lnVCnt+5,WCOLS()-13 COLOR (SCHEME(10,2))
		WAIT WINDOW "Saving..." TIMEOUT 0.2
		* Exit...
		lcStatus="OK"
		llExit=.T.
	CASE lcStat="Cancel"
		* Simulate button press...
		@ lnVCnt+5,WCOLS()-10 FILL TO lnVCnt+5,WCOLS()-3 COLOR (SCHEME(10,2))
		WAIT WINDOW "Canceling..." TIMEOUT 0.2
		* Exit...
		lcStatus="Cancel"
		llExit=.T.
ENDCASE
	
